

#include "Arduino.h"
#include "Wire.h"

#include "EsDisplay.h"


EsDisplay::EsDisplay(){
  Wire.begin(); 
  
}

  
byte nums[10] = {
63,
6,
91,
79,
102,
109,
124,
7,
127,
103};

 void EsDisplay::showNumOnPos(byte num, byte pos,bool dot) {
  byte n = nums[num];
  if(dot){
    n+= 128;}
  Wire.beginTransmission(0x27);
  Wire.write((uint8_t)pos);
  Wire.write((uint8_t)n);
  Wire.endTransmission();
}

byte symbols[2] = {
0, //prazdno
64 //-
};

void EsDisplay::showSymbolOnPos(byte symbol, byte pos,bool dot){
  byte n = symbols[symbol];
  if(dot){
    n+= 128;}
  Wire.beginTransmission(0x27);
  Wire.write((uint8_t)pos);
  Wire.write((uint8_t)n);
  Wire.endTransmission();
    
}


void EsDisplay::showNumber(int num){ 
  if(num > 9999 || num < 0) {
    for(int i = 0; i < 4; i++){
      showSymbolOnPos(1,i,false);
    }
    return;
  }       
       byte n1 = num%10;
       byte n2 = (((num-n1)%100)/10)%10;
       byte n3 = (((num-n1-n2*10))/100)%10;
       byte n4 = (((num-n1-n2*10-n3*100))/1000)%10;
       
       
  bool stillEmpty = true;
  
  if(n4) {
    stillEmpty = false;
    showNumOnPos(n4,0,false);
  } else {
    showSymbolOnPos(n4,0,false);
  }
  
  if(stillEmpty){
    if(n3) {
      stillEmpty = false;
      showNumOnPos(n3,1,false);
    } else {
      showSymbolOnPos(0,1,false);
    }
  } else {
    showNumOnPos(n3,1,false);
  }
  
  if(stillEmpty){
    if(n2) {
      stillEmpty = false;
      showNumOnPos(n2,2,false);
    } else {
      showSymbolOnPos(0,2,false);
    }
  }  else {
    showNumOnPos(n2,2,false);
  }
  
  showNumOnPos(n1,3,false);
       
       
       
       
  
  
  
}

void EsDisplay::showNumberWithMinus(int num){
if(num < -999) {
    for(int i = 0; i < 4; i++){
      showSymbolOnPos(1,i,false);
    }
    return;
  }    
  if(num >= 0) 
    showNumber(num);
  else
    showNumber(num*(-1));
    
    //zobrazeni minusu
  if(num < -99)
  showSymbolOnPos(1,0,false);
  else if(num < -9)
    showSymbolOnPos(1,1,false);
  else if(num < 0) 
    showSymbolOnPos(1,2,false);

    
          
}

byte letters[4] = {
    119, //A
    127, //B
    57, //C
    63 //D
} ;

void EsDisplay::showLetterOnPos(char letter, byte pos,bool dot){

 byte n = letters[(byte)letter-65];
  if(dot){
    n+= 128;}
  Wire.beginTransmission(0x27);
  Wire.write((uint8_t)pos);
  Wire.write((uint8_t)n);
  Wire.endTransmission();
}
